<div [ngStyle]="{'display': template_manage.caaStatus === 'show' ? 'none' : '' }">
  <div class="d-flex bd-highlight">
    <div class="p-2 w-100 bd-highlight">
      <div>
        <a class="pps-header" style="font-size: 28px;">เป้าหมาย/ตัวชี้วัด </a>
      </div>
      <p class="pps-header_th">
        เพิ่มรายละเอียดเป้าหมาย/ตัวชี้วัด เกี่ยวกับรายละเอียดผลิตภัณฑ์
      </p>
    </div>
    <div class="pt-2 flex-shrink-1 bd-highlight d-flex">
      <div *ngIf="(validate === true || validate === null)">
        <button type="button" class="btn btn-primary saveDraft" (click)="saveDraftData()">
          บันทึกร่างใบคำขอ
        </button>
      </div>

      <!-- <div *ngIf="userRole === 'PO'">
        <button
          type="button"
          class="btn btn-primary sandwork"
          (click)="sandwork()"
        >
          ส่งงาน
        </button>
      </div> -->
    </div>
  </div>

  <div class="alert alert-success" role="alert" [ngStyle]="{ display: saveDraftstatus !== 'success' ? 'none' : '' }">
    <a class="alert-detail"><img src="../../../../../assets/img/checkmark.png" class="icon_checkmark" />
      บันทึกร่างใบคำขอเรียบร้อย</a>
  </div>
</div>
<br />
<!-- ============================================= new =================================================== -->
<div id="accordion">
  <div class="card" id="headingOne">
    <div class="card-header" id="headingOne"
      [ngStyle]="{'display': template_manage.caaStatus === 'show' ? 'none' : '' }">
      <div class="d-flex" style="width: 100%; height: 30%;">
        <div class="btn text-header-panel">
          รายละเอียดที่ต้องการนำเสนอในครั้งนี้
        </div>
        <a *ngIf="showData === true" class="btn btn-link" data-toggle="collapse" data-target="#collapseOne"
          aria-expanded="true" aria-controls="collapseOne" (click)="show()">
          แสดงผลเพิ่มเติม
        </a>

        <a *ngIf="showData !== true" class="btn btn-link" data-toggle="collapse" data-target="#collapseOne"
          aria-expanded="true" aria-controls="collapseOne" (click)="show()">
          แสดงผลน้อยลง

        </a>
      </div>
    </div>
    <button id="chckDisableDelete" style="display: none;" (click)="chckDisableDelete()"></button>
    <div id="collapseOne" class="collapse show" aria-labelledby="headingOne">
      <div class="card-body">
        <!-- <app-step-nine
          [template_manage]="{ role: null, validate: null, caaStatus: 'show' }"
        ></app-step-nine> -->


        <!-- =========================================================================== -->
        <!--------------------------------- create new------------------------------------->
        <div style="padding-left: 10px;">
          <!-------------------------------------------- ตารางเป้าหมาย/ตัวชี้วัด ---------------------------------------------------->
          <div class="row">
            <div class="col-12">
              <p class="head-detal">ตารางเป้าหมาย/ตัวชี้วัด</p>
            </div>
            <div class="col-12">
              <hr>
            </div>
            <div class="col-12">
              <div style="overflow: auto;">
                <table class="table-proccess table table-striped">
                  <!-- ----------------------- thead ---------------------------- -->
                  <thead>
                    <tr>
                      <th rowspan="3" style="vertical-align: top; padding: 10px; min-width: 200px;" class="text-nowrap">
                        ตัวชี้วัด</th>
                      <th [attr.colspan]="stepTen[0].original.year.length"
                        style="text-align: center; padding: 10px; border-bottom: 1px solid #C0C0C0;">เป้าหมาย (เดิม)
                      </th>
                      <th rowspan="3" style="min-width: 10px; width: 10px; max-width: 10px;"></th>
                      <th *ngIf="validate === true" [attr.colspan]="stepTen[0].newContent.year.length"
                        style="text-align: center; padding: 10px;">เป้าหมาย (ใหม่)</th>
                      <th *ngIf="validate === true"></th>
                      <th *ngIf="validate === false" [attr.colspan]="stepTen[0].newContent.year.length"
                        style="text-align: center; padding: 10px; border-bottom: 1px solid #C0C0C0;">เป้าหมาย (ใหม่)
                      </th>
                      <th rowspan="3" style="min-width: 10px; width: 10px; max-width: 10px;"></th>
                      <th [attr.colspan]="3"
                        style="text-align: center; padding: 10px; border-bottom: 1px solid #C0C0C0;">เกิดขึ้นจริง</th>
                    </tr>
                    <tr>
                      <th *ngFor="let item of stepTen[0].original.year; index as i" rowspan="2"
                        style="padding-top: 5px; padding-left: 5px; padding-right: 5px; min-width: 270px; width: 270px; max-width: 270px; text-align: center; vertical-align: middle;">
                        ปี พ.ศ. {{item}}
                      </th>
                      <th *ngFor="let item of stepTen[0].newContent.year; index as i"
                        style="padding-top: 5px; padding-left: 5px; padding-right: 5px; width: 270px; vertical-align: middle; border: 0px;">
                        <div class="input-head-td" *ngIf="i == 0 && validate === true">
                          <!-- {{rowYear[0] | json}} -->
                          <input type="number" class="form-control" style="text-align: left; width: 260px;"
                            placeholder="" [(ngModel)]="rowYear[0]" (change)="checkDisabledYear()"
                            (ngModelChange)="changeSaveDraft()">
                          <span class="finan-year" *ngIf="rowYear[0]">ปี พ.ศ.</span>
                        </div>
                        <div *ngIf="i == 0 && validate === false" style="text-align: center;">
                          <span>ปี พ.ศ. </span><span *ngIf="rowYear[0]">{{ rowYear[0]}}</span>
                        </div>
                        <div *ngIf="i > 0 " style="text-align: center;">
                          <span>ปี พ.ศ. </span><span *ngIf="rowYear[0]">{{ rowYear[0] + i}}</span>
                        </div>
                      </th>
                      <th *ngIf="validate === true" style="width: 140px; text-align: center;">
                        <button type="button" class="btn add_year" (click)="addYear(0)"><img
                            src="../../../../../assets/img/add_white.svg">
                          <a>เพิ่มปี</a>
                        </button>
                      </th>
                      <th rowspan="2"
                        style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                        สะสมถึงปัจจุบัน
                      </th>
                      <th rowspan="2"
                        style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                        ปีปัจจุบัน
                      </th>
                    </tr>
                    <tr *ngIf="validate === true" [ngStyle]="{'display': (disabledRowAll) ? 'none' : '' }">
                      <th *ngFor="let item of stepTen[0].newContent.year; index as j" style="text-align: center;">
                        <div class="popup" [attachOutsideOnClick]="attachOutsideOnClick"
                          (clickOutside)="onClickedOutsideYear(j)">
                          <a [ngClass]="{'delete-btn-select': popUpShowRow === j, 'delete-btn': popUpShowRow !== j}"
                            (click)="popUpRow(j)">ลบข้อมูล</a>
                          <div class="row popuptext" [ngStyle]="{'display': !(popUpShowRow === j) ? 'none' : '' }"
                            id="popupRow">
                            <a class="col-6 delete-btn-sub pr-1" style="border-right: 1px solid #F2F2F2;"
                              (click)="deleteRowDetail(j)">ลบข้อมูล</a>
                            <a class="col-6 delete-btn-sub pl-1" (click)="deleteRow(j)">ลบคอลัมน์</a>
                          </div>
                        </div>
                      </th>
                      <th></th>
                    </tr>
                  </thead>
                  <!-- tbody -->
                  <tbody>
                    <!-- ==================================== ปริมาณธุรกรรม ============================================ -->
                    <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                      <td class="text-nowrap dataDtailHead" style="padding: 10px;">ปริมาณธุรกรรม</td>
                      <td *ngIf="stepTen[0].original.year.length > 0;"
                        [attr.colspan]="stepTen[0].original.year.length + stepTen[0].newContent.year.length + 1"
                        class="pd-0"></td>
                      <td *ngIf="validate === true"
                        style="min-width: 140px; max-width: 140px; width:  140px; padding: 5px; text-align: center; vertical-align: middle;">
                        <button type="button" class="btn add_table" (click)="addTable('transaction')"><img
                            src="../../../../../assets/img/add_white.svg">
                          <a>เพิ่มข้อมูล</a>
                        </button>
                      </td>
                      <td [attr.colspan]="3"></td>
                    </tr>
                    <!----------------------- sub transaction table  ------------------------->
                    <tr>
                      <td
                        [attr.colspan]="1 + stepTen[0].original.year.length + 1 + stepTen[0].newContent.year.length + 1 + 3"
                        style="padding: 0px;">
                        <table class="table-proccess-data" cdkDropList
                          [cdkDropListData]="stepTen[0].newContent.transaction"
                          (cdkDropListDropped)="dropTransaction($event)">
                          <tr *ngFor="let detalItem of stepTen[0].newContent.transaction; index as iSub"
                            [cdkDragData]="stepTen[0].newContent.transaction" cdkDrag
                            [cdkDragDisabled]="stepTen[0].newContent.transaction[iSub].dataDraft == false">
                            <td
                              style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                              <div *ngIf="validate === true">
                                <div class="ml-3"
                                  *ngIf="stepTen[0].newContent.transaction[iSub].dataDraft == false ; else stepNineNonDataName">
                                  <textarea *ngIf="chckDisableDelete(stepTen[0].newContent.transaction[iSub]) == false"
                                    (ngModelChange)="changeSaveDraft()" appTextareaAutoresize autocomplete="off"
                                    class="form-control"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ"
                                    [(ngModel)]="stepTen[0].newContent.transaction[iSub].title">
                                </textarea>
                                  <div *ngIf="chckDisableDelete(stepTen[0].newContent.transaction[iSub]) == true">
                                    {{stepTen[0].newContent.transaction[iSub].title}}</div>

                                  <!-- {{stepTen[0].newContent.transaction[iSub].title}} -->
                                </div>
                                <ng-template #stepNineNonDataName>
                                  <!-- <img cdkDragHandle class="icongrap" src="assets/img/grip-vertical.svg" alt=""> -->
                                  <textarea class="form-control ml-2"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ" [(ngModel)]="stepTen[0].newContent.transaction[iSub].title"
                                    appTextareaAutoresize autocomplete="off"
                                    (ngModelChange)="checkDisabledRow('transaction', iSub); changeSaveDraft()" required>
                                  </textarea>
                                </ng-template>
                              </div>
                              <div *ngIf="validate === false">
                                <div class="ml-3">
                                  {{stepTen[0].newContent.transaction[iSub].title}}
                                </div>
                              </div>

                            </td>
                            <!-- check if parentTranx === 0 then create empty td -->
                            <ng-container
                              *ngIf="stepTen[0].original.transaction[iSub].parentTranx.length !== 0;else zeroParentTranx">
                              <td *ngFor="let Item of stepTen[0].original.transaction[iSub].parentTranx; index as iyear"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{Item}}
                                </div>
                              </td>
                            </ng-container>
                            <ng-template #zeroParentTranx>
                              <td [attr.colspan]="stepTen[0].original.year.length"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div></div>
                              </td>
                            </ng-template>


                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                            <td
                              *ngFor="let itemNew of stepTen[0].newContent.transaction[iSub].tranx;let iyear = index; trackBy trackByFn"
                              style="min-width: 270px;width: 270px;max-width: 270px; padding: 5px; text-align: center;">
                              <div *ngIf="validate === true">

                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  style="width: 260px;" [(ngModel)]="transaction_row[iSub]?.data[iyear]"
                                  (ngModelChange)="checkDisabledRow('transaction', iSub); changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{transaction_row[iSub]?.data[iyear]}}
                              </div>
                            </td>

                            <td *ngIf="validate === true"
                              style="vertical-align: middle; min-width: 140px; max-width: 140px; width: 140px; text-align: center;">
                              <div class="popup" [attachOutsideOnClick]="attachOutsideOnClick"
                                (clickOutside)="onClickedOutsideDetal('transaction', iSub)">
                                <a *ngIf="stepTen[0].newContent.transaction[iSub].disabledCol == false;"
                                  [class.disabled]="chckDisableDelete(stepTen[0].newContent.transaction[iSub]) == true"
                                  [ngClass]="{'delete-btn-select': (popUpShowCol[0].indextable === 'transaction'  && this.popUpShowCol[0].indexCol === iSub) , 'delete-btn': !(popUpShowCol[0].indextable == 'transaction'  && this.popUpShowCol[0].indexCol === iSub) }"
                                  (click)="popUpCol('transaction', iSub)">ลบข้อมูล</a>
                                <div class="row popuptextCol shadow"
                                  [ngStyle]="{'display': !(popUpShowCol[0].indextable === 'transaction'  && this.popUpShowCol[0].indexCol === iSub) ? 'none' : '' }"
                                  id="popupCol">
                                  <a class="col-6 delete-btn-sub pr-1" style="border-right: 1px solid #F2F2F2;"
                                    (click)="deleteColDetail('transaction', iSub)">ลบข้อมูล</a>
                                  <a class="col-6 delete-btn-sub pl-1"
                                    (click)="deleteCol('transaction', iSub)">ลบแถว</a>
                                </div>
                              </div>
                            </td>
                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="detalItem.cumulative" (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{detalItem.cumulative}}
                              </div>
                            </td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="detalItem.now" (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{detalItem.now}}
                              </div>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                    <!-- --------------------------------------------------------------------------------- -->
                    <!-- ==================================== end ปริมาณธุรกรรม ============================================ -->

                    <!-- ==================================== ผลตอบแทน ============================================ -->
                    <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                      <td class="text-nowrap dataDtailHead" style="padding: 10px;">ผลตอบแทน</td>
                      <td *ngIf="stepTen[0].original.year.length > 0;"
                        [attr.colspan]="stepTen[0].original.year.length  + stepTen[0].newContent.year.length + 1"
                        class="pd-0"></td>
                      <td *ngIf="validate === true"
                        style="min-width: 140px; max-width: 140px; width:  140px; padding: 5px; text-align: center; vertical-align: middle;">
                        <button type="button" class="btn add_table" (click)="addTable('compensation')"><img
                            src="../../../../../assets/img/add_white.svg">
                          <a>เพิ่มข้อมูล</a>
                        </button>
                      </td>
                      <td [attr.colspan]="3"></td>
                    </tr>
                    <!----------------------- sub compensation table  ------------------------->
                    <tr>
                      <td
                        [attr.colspan]="1 + stepTen[0].original.year.length + 1 + stepTen[0].newContent.year.length + 1 + 3"
                        style="padding: 0px;">
                        <table class="table-proccess-data" cdkDropList
                          [cdkDropListData]="stepTen[0].newContent.compensation"
                          (cdkDropListDropped)="dropCompensation($event)">
                          <tr *ngFor="let detalItem of stepTen[0].newContent.compensation; index as iSub"
                            [cdkDragData]="stepTen[0].newContent.compensation" cdkDrag
                            [cdkDragDisabled]="stepTen[0].newContent.compensation[iSub].dataDraft == false">
                            <td
                              style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                              <div *ngIf="validate === true">
                                <div class="ml-3"
                                  *ngIf="stepTen[0].newContent.compensation[iSub].dataDraft == false; else stepNineNonDataName">
                                  <textarea *ngIf="chckDisableDelete(stepTen[0].newContent.compensation[iSub]) == false"
                                    class="form-control"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ" appTextareaAutoresize autocomplete="off"
                                    (ngModelChange)="changeSaveDraft()"
                                    [(ngModel)]="stepTen[0].newContent.compensation[iSub].title">
                                  </textarea>
                                  <div *ngIf="chckDisableDelete(stepTen[0].newContent.compensation[iSub]) == true">
                                    {{stepTen[0].newContent.compensation[iSub].title}}</div>
                                </div>

                                <ng-template #stepNineNonDataName>
                                  <!-- <img cdkDragHandle class="icongrap" src="assets/img/grip-vertical.svg" alt=""> -->
                                  <textarea class="form-control ml-2"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ"
                                    [(ngModel)]="stepTen[0].newContent.compensation[iSub].title" appTextareaAutoresize
                                    autocomplete="off"
                                    (ngModelChange)="checkDisabledRow('compensation', iSub); changeSaveDraft()"
                                    required>
                                  </textarea>
                                </ng-template>
                              </div>

                              <div *ngIf="validate === false">
                                <div class="ml-3">
                                  {{stepTen[0].newContent.compensation[iSub].title}}
                                </div>
                              </div>
                            </td>

                            <!-- <td *ngFor="let Item of stepTen[0].original.compensation[iSub].parentTranx; index as iyear"
                              style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                              <div>sssss
                                {{stepTen[0].original.compensation[iSub].parentTranx[iyear]}}
                              </div>
                            </td> -->

                            <!-- check if parentTranx === 0 then create empty td -->
                            <ng-container
                              *ngIf="stepTen[0].original.compensation[iSub].parentTranx.length !== 0;else zeroParentTranxtwo">
                              <td
                                *ngFor="let Item of stepTen[0].original.compensation[iSub].parentTranx; index as iyear"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{Item}}
                                </div>
                              </td>
                            </ng-container>
                            <ng-template #zeroParentTranxtwo>
                              <td [attr.colspan]="stepTen[0].original.year.length"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div></div>
                              </td>
                            </ng-template>

                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                            <td
                              *ngFor="let itemNew of stepTen[0].newContent.compensation[iSub].tranx; let iyear = index; trackBy trackByFn"
                              style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  style="width: 260px;" [(ngModel)]="compensation_row[iSub]?.data[iyear]"
                                  (ngModelChange)="checkDisabledRow('compensation', iSub); changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{compensation_row[iSub]?.data[iyear]}}
                              </div>
                              <!-- iSub: {{iSub}} || iyear: {{iyear}} stepTen[0].newContent.compensation[0].tranx[iyear] -->
                            </td>

                            <td *ngIf="validate === true"
                              style="vertical-align: middle; min-width: 140px; max-width: 140px; width: 140px; text-align: center;">
                              <div class="popup" [attachOutsideOnClick]="attachOutsideOnClick"
                                (clickOutside)="onClickedOutsideDetal('compensation', iSub)">
                                <a *ngIf="stepTen[0].newContent.compensation[iSub].disabledCol == false;"
                                  [class.disabled]="chckDisableDelete(stepTen[0].newContent.compensation[iSub]) == true"
                                  [ngClass]="{'delete-btn-select': (popUpShowCol[0].indextable === 'compensation'  && this.popUpShowCol[0].indexCol === iSub) , 'delete-btn': !(popUpShowCol[0].indextable == 'compensation'  && this.popUpShowCol[0].indexCol === iSub) }"
                                  (click)="popUpCol('compensation', iSub)">ลบข้อมูล</a>
                                <div class="row popuptextCol shadow"
                                  [ngStyle]="{'display': !(popUpShowCol[0].indextable === 'compensation'  && this.popUpShowCol[0].indexCol === iSub) ? 'none' : '' }"
                                  id="popupCol">
                                  <a class="col-6 delete-btn-sub pr-1" style="border-right: 1px solid #F2F2F2;"
                                    (click)="deleteColDetail('compensation', iSub)">ลบข้อมูล</a>
                                  <a class="col-6 delete-btn-sub pl-1"
                                    (click)="deleteCol('compensation', iSub)">ลบแถว</a>
                                </div>
                              </div>
                            </td>
                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="stepTen[0].newContent.compensation[iSub].cumulative"
                                  (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{stepTen[0].newContent.compensation[iSub].cumulative}}
                              </div>
                            </td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="stepTen[0].newContent.compensation[iSub].now"
                                  (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{stepTen[0].newContent.compensation[iSub].now}}
                              </div>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                    <!-- --------------------------------------------------------------------------------- -->
                    <!-- ==================================== end ผลตอบแทน ============================================ -->

                    <!-- ==================================== การควบคุม ============================================ -->
                    <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                      <td class="text-nowrap dataDtailHead" style="padding: 10px;">การควบคุม</td>
                      <td *ngIf="stepTen[0].original.year.length  > 0;"
                        [attr.colspan]="stepTen[0].original.year.length  + stepTen[0].newContent.year.length + 1"
                        class="pd-0"></td>
                      <td *ngIf="validate === true"
                        style="min-width: 140px; max-width: 140px; width:  140px; padding: 5px; text-align: center; vertical-align: middle;">
                        <button type="button" class="btn add_table" (click)="addTable('control')"><img
                            src="../../../../../assets/img/add_white.svg">
                          <a>เพิ่มข้อมูล</a>
                        </button>
                      </td>
                      <td [attr.colspan]="3"></td>
                    </tr>
                    <!----------------------- sub control table  ------------------------->
                    <tr>
                      <td
                        [attr.colspan]="1 + stepTen[0].original.year.length + 1 + stepTen[0].newContent.year.length + 1 + 3"
                        style="padding: 0px;">
                        <table class="table-proccess-data" cdkDropList [cdkDropListData]="stepTen[0].newContent.control"
                          (cdkDropListDropped)="dropControl($event)">
                          <tr *ngFor="let detalItem of stepTen[0].newContent.control; index as iSub"
                            [cdkDragData]="stepTen[0].newContent.control" cdkDrag
                            [cdkDragDisabled]="stepTen[0].newContent.control[iSub].dataDraft == false">
                            <td
                              style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                              <div *ngIf="validate === true">
                                <div class="ml-3"
                                  *ngIf="stepTen[0].newContent.control[iSub].dataDraft == false; else stepNineNonDataName">
                                  <!-- {{stepTen[0].newContent.control[iSub].title}} -->
                                  <textarea *ngIf="chckDisableDelete(stepTen[0].newContent.control[iSub]) == false"
                                    class="form-control"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ" appTextareaAutoresize autocomplete="off"
                                    (ngModelChange)="changeSaveDraft()"
                                    [(ngModel)]="stepTen[0].newContent.control[iSub].title">
                                </textarea>
                                  <div *ngIf="chckDisableDelete(stepTen[0].newContent.control[iSub]) == true">
                                    {{stepTen[0].newContent.control[iSub].title}}</div>
                                </div>
                                <ng-template #stepNineNonDataName>
                                  <!-- <img cdkDragHandle class="icongrap" src="assets/img/grip-vertical.svg" alt=""> -->
                                  <textarea class="form-control ml-2"
                                    style="padding-top: 0px;padding-bottom: 0px; height: 48px;overflow:hidden"
                                    placeholder="อื่นๆ ระบุ" [(ngModel)]="stepTen[0].newContent.control[iSub].title"
                                    appTextareaAutoresize autocomplete="off"
                                    (ngModelChange)="checkDisabledRow('control', iSub); changeSaveDraft()" required>
                                  </textarea>
                                </ng-template>
                              </div>
                              <div *ngIf="validate === false">
                                <div class="ml-3">
                                  {{stepTen[0].newContent.control[iSub].title}}
                                </div>
                              </div>

                            </td>

                            <!-- <td *ngFor="let Item of stepTen[0].original.control[iSub].parentTranx; index as iyear;"
                              style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                              <div>
                                {{stepTen[0].original.control[iSub].parentTranx[iyear]}}
                              </div>
                            </td> -->

                            <!-- check if parentTranx === 0 then create empty td -->
                            <ng-container
                              *ngIf="stepTen[0].original.control[iSub].parentTranx.length !== 0;else zeroParentTranxthree">
                              <td *ngFor="let Item of stepTen[0].original.control[iSub].parentTranx; index as iyear"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{Item}}
                                </div>
                              </td>
                            </ng-container>
                            <ng-template #zeroParentTranxthree>
                              <td [attr.colspan]="stepTen[0].original.year.length"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div></div>
                              </td>
                            </ng-template>

                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                            <td
                              *ngFor="let itemNew of stepTen[0].newContent.control[iSub].tranx; let iyear = index; trackBy trackByFn"
                              style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  style="width: 260px;" [(ngModel)]="control_row[iSub]?.data[iyear]"
                                  (ngModelChange)="checkDisabledRow('control', iSub); changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{control_row[iSub]?.data[iyear]}}
                              </div>
                            </td>

                            <td *ngIf="validate === true"
                              style="vertical-align: middle; min-width: 140px; max-width: 140px; width: 140px; text-align: center;">
                              <div class="popup" [attachOutsideOnClick]="attachOutsideOnClick"
                                (clickOutside)="onClickedOutsideDetal('control', iSub)">
                                <a *ngIf="stepTen[0].newContent.control[iSub].disabledCol == false;"
                                  [class.disabled]="chckDisableDelete(stepTen[0].newContent.control[iSub]) == true"
                                  [ngClass]="{'delete-btn-select': (popUpShowCol[0].indextable === 'control'  && this.popUpShowCol[0].indexCol === iSub) , 'delete-btn': !(popUpShowCol[0].indextable == 'control'  && this.popUpShowCol[0].indexCol === iSub) }"
                                  (click)="popUpCol('control', iSub)">ลบข้อมูล</a>
                                <div class="row popuptextCol shadow"
                                  [ngStyle]="{'display': !(popUpShowCol[0].indextable === 'control'  && this.popUpShowCol[0].indexCol === iSub) ? 'none' : '' }"
                                  id="popupCol">
                                  <a class="col-6 delete-btn-sub pr-1" style="border-right: 1px solid #F2F2F2;"
                                    (click)="deleteColDetail('control', iSub)">ลบข้อมูล</a>
                                  <a class="col-6 delete-btn-sub pl-1" (click)="deleteCol('control', iSub)">ลบแถว</a>
                                </div>
                              </div>
                            </td>
                            <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="stepTen[0].newContent.control[iSub].cumulative"
                                  (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{stepTen[0].newContent.control[iSub].cumulative}}
                              </div>
                            </td>
                            <td
                              style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                              <div *ngIf="validate === true">
                                <input type="text" class="form-control" placeholder="ระบุรายละเอียด"
                                  [(ngModel)]="stepTen[0].newContent.control[iSub].now"
                                  (ngModelChange)="changeSaveDraft()">
                              </div>
                              <div *ngIf="validate === false">
                                {{stepTen[0].newContent.control[iSub].now}}
                              </div>
                            </td>
                          </tr>
                        </table>
                      </td>
                    </tr>
                    <!-- --------------------------------------------------------------------------------- -->
                    <!-- ==================================== end การควบคุม ============================================ -->

                  </tbody>
                </table>
                <br>
              </div>
            </div>
            <div class="col-12">
              <p class="head-detal">กรุณาระบุเหตุผลในกรณีผลการดำเนินงานไม่บรรลุตามเป้าหมาย
                และผู้จัดการผลิตภัณฑ์เห็นสมควร</p>
            </div>
            <div class="col-12" *ngIf="validate === false">
              <hr style="margin-top: 0px; margin-bottom: 20px;">
            </div>
            <div class="col-12" *ngIf="validate === true">
              <textarea class="form-control input-detail" rows="4" cols="50" placeholder="เพิ่มรายละเอียดเหตุผล"
                [(ngModel)]="stepTen[0].reason" (ngModelChange)="changeSaveDraft()"></textarea>
            </div>
            <div class="col-12" *ngIf="validate === false" style="word-wrap: break-word;">
              {{stepTen[0].reason}}
            </div>
          </div>

        </div>
        <!--------------------------------------------------------------------------------->
        <!-- ============================================================================ -->

      </div>
    </div>
  </div>
  <!-- ==================================================== old ====================================================== -->


  <!-- start collapse -->
  <div *ngIf="res?.repeat === true" [ngStyle]="{'display': template_manage.caaStatus === 'show' ? 'none' : '' }">
    <div class="card" *ngFor="let year of res?.data?.parentRequestId;let iParent = index">
      <div class="card-header">
        <div class="d-flex" style="width: 100%; height: 30%;">
          <div class="btn text-header-panel">
            รายละเอียดที่นำเสนอในครั้งก่อน ( {{year.lastReviewDate}} )
          </div>
          <a *ngIf="showsearch[iParent].value  === true" class="btn btn-link" data-toggle="collapse"
            [attr.href]="'#collapse_' + iParent" aria-expanded="true"
            (click)="createTableParent(year['requestId'], collapseStateIndex[iParent], iParent); showSearch(iParent)">
            แสดงผลเพิ่มเติม
          </a>
          <a *ngIf="showsearch[iParent].value  === false" class="btn btn-link" data-toggle="collapse"
            [attr.href]="'#collapse_' + iParent" aria-expanded="true"
            (click)="createTableParent(year['requestId'], collapseStateIndex[iParent], iParent); showSearch(iParent)">
            แสดงผลน้อยลง
          </a>
        </div>
      </div>

      <div [attr.id]="'collapse_' + iParent" class="collapse">
        <div class="card-body" *ngIf="parentStepTen?.length > 0">
          <!-- =========================================================================== -->
          <!--------------------------------- create new------------------------------------->
          <div style="padding-left: 10px;">
            <!-------------------------------------------- ตารางเป้าหมาย/ตัวชี้วัด ---------------------------------------------------->
            <div class="row">
              <div class="col-12">
                <p class="head-detal">ตารางเป้าหมาย/ตัวชี้วัด</p>
              </div>
              <div class="col-12">
                <hr>
              </div>
              <div class="col-12">
                <div style="overflow: auto;">
                  <table class="table-proccess table table-striped">
                    <!-- ----------------------- thead ---------------------------- -->
                    <thead>
                      <tr>
                        <th rowspan="2" style="vertical-align: top; padding: 10px; min-width: 200px;"
                          class="text-nowrap">ตัวชี้วัด
                        </th>
                        <!-- *ngIf="parentStepTen[iParent]?.repeat" -->
                        <th [attr.colspan]="parentStepTen[iParent]?.data?.goal.parentYear.length"
                          style="text-align: center; padding: 10px; ">
                          <div style="height: 44px;border-bottom: 1px solid #C0C0C0;">
                            เป้าหมาย (เดิม)
                          </div>
                        </th>
                        <!-- *ngIf="parentStepTen[iParent]?.repeat" -->
                        <th rowspan="2" *ngIf="parentStepTen[iParent]?.repeat"
                          style="min-width: 1px; width: 1px; max-width: 1px;"></th>
                        <!--  -->
                        <th [attr.colspan]="parentStepTen[iParent]?.data?.goal.year.length"
                          style="text-align: center; padding: 10px;">
                          <div style="height: 44px;border-bottom: 1px solid #C0C0C0;">
                            เป้าหมาย (ใหม่)
                          </div>
                        </th>
                        <th rowspan=2 style="min-width: 10px; width: 10px; max-width: 10px;"></th>
                        <th colspan="3" style="text-align: center; padding: 10px;">
                          <div style="height: 44px;border-bottom: 1px solid #C0C0C0;">
                            เกิดขึ้นจริง
                          </div>
                         </th>
                      </tr>
                      <tr>
                        <th *ngFor="let itemYear of parentStepTen[iParent]?.data?.goal.parentYear; index as i"
                          style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 270px; width: 270px; max-width: 270px; text-align: center;">
                          ปี พ.ศ. {{itemYear}}
                        </th>

                        <th *ngFor="let itemYear of parentStepTen[iParent]?.data?.goal.year; index as i"
                          style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 270px; width: 270px; max-width: 270px; text-align: center;">
                          ปี พ.ศ. {{itemYear}}
                          <!-- {{parentStepTen[iParent]?.repeat | json}} -->
                          <!-- {{parentStepTen[iParent]?.data?.goal.parentYear.length | json}} -->
                        </th>

                        <th
                          style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                          สะสมถึงปัจจุบัน
                        </th>
                        <th
                          style="padding-top: 10px; padding-left: 5px; padding-right: 5px; min-width: 470px; width: 470px; max-width: 470px; text-align: center;">
                          ปีปัจจุบัน
                        </th>
                      </tr>
                    </thead>
                    <!-- tbody -->
                    <tbody>
                      <!-- ==================================== ปริมาณธุรกรรม ============================================ -->
                      <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                        <td class="text-nowrap dataDtailHead" style="padding: 10px;">ปริมาณธุรกรรม</td>
                        <td *ngIf="parentStepTen[iParent]?.data?.goal.parentYear.length > 0;else noParent"
                          [attr.colspan]="parentStepTen[iParent]?.data?.goal.parentYear.length + parentStepTen[iParent]?.data?.goal.year.length + 1"
                          class="pd-0"></td>
                        <ng-template #noParent>
                          <td [attr.colspan]="parentStepTen[iParent]?.data?.goal.year.length + 1" class="pd-0"></td>
                        </ng-template>
                        <td></td>
                        <td colspan="2"></td>
                      </tr>
                      <!----------------------- sub transaction table  ------------------------->
                      <tr>
                        <td [attr.colspan]="parentStepTen[iParent]?.repeat ? 
                        (1 + parentStepTen[iParent]?.data?.goal.parentYear.length + 1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3) 
                        : (1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3)" style="padding: 0px;">
                          <table class="table-proccess-data">
                            <tr
                              *ngFor="let transaction of parentStepTen[iParent]?.data?.goal.transaction; index as iSub">
                              <td
                                style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                                <div class="ml-3">
                                  {{transaction.title}}
                                </div>
                              </td>

                              <td *ngFor="let pTranx of transaction.parentTranx"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{pTranx}}
                                </div>
                              </td>

                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                              <td *ngFor="let tranx of transaction.tranx"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{tranx}}
                                </div>
                              </td>
                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{transaction.cumulative}}
                                </div>
                              </td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{transaction.now}}
                                </div>
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                      <!-- --------------------------------------------------------------------------------- -->
                      <!-- ==================================== end ปริมาณธุรกรรม ============================================ -->

                      <!-- ==================================== ผลตอบแทน ============================================ -->
                      <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                        <td class="text-nowrap dataDtailHead" style="padding: 10px;">ผลตอบแทน</td>
                        <td *ngIf="parentStepTen[iParent]?.data.goal.parentYear.length > 0;else noParent"
                          [attr.colspan]="parentStepTen[iParent]?.data?.goal.parentYear.length + parentStepTen[iParent]?.data?.goal.year.length + 1"
                          class="pd-0"></td>
                        <ng-template #noParent>
                          <td [attr.colspan]="parentStepTen[iParent]?.data?.goal.year.length + 1" class="pd-0"></td>
                        </ng-template>
                        <td
                          [attr.colspan]="parentStepTen[iParent]?.data?.goal.parentYear.length + parentStepTen[iParent]?.data?.goal.year.length + 1">
                        </td>
                      </tr>
                      <!----------------------- sub compensation table  ------------------------->
                      <tr>
                        <td [attr.colspan]="parentStepTen[iParent]?.repeat ? 
                        (1 + parentStepTen[iParent]?.data?.goal.parentYear.length + 1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3) 
                        : (1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3)" style="padding: 0px;">
                          <table class="table-proccess-data">
                            <tr
                              *ngFor="let compensation of parentStepTen[iParent]?.data?.goal.compensation; index as iSub">
                              <td
                                style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                                <div class="ml-3">
                                  {{compensation.title}}
                                </div>
                              </td>

                              <td *ngFor="let pTranx of compensation.parentTranx"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{pTranx}}
                                </div>
                              </td>

                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                              <td *ngFor="let tranx of compensation.tranx; index as iyear"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{tranx}}
                                </div>
                              </td>
                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{compensation.cumulative}}
                                </div>
                              </td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{compensation.now}}
                                </div>
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                      <!-- --------------------------------------------------------------------------------- -->
                      <!-- ==================================== end ผลตอบแทน ============================================ -->

                      <!-- ==================================== การควบคุม ============================================ -->
                      <tr style="background-color: #F2F2F2;border-top: 5px solid #F2F2F2;">
                        <td class="text-nowrap dataDtailHead" style="padding: 10px;">การควบคุม</td>
                        <td *ngIf="parentStepTen[iParent]?.data?.goal.parentYear.length > 0;else noParent"
                          [attr.colspan]="parentStepTen[iParent]?.data?.goal.parentYear.length + parentStepTen[iParent].data?.goal.year.length + 1"
                          class="pd-0"></td>
                        <ng-template #noParent>
                          <td [attr.colspan]="parentStepTen[iParent]?.data?.goal.year.length + 1" class="pd-0"></td>
                        </ng-template>
                        <td [attr.colspan]="3"></td>
                      </tr>
                      <!----------------------- sub control table  ------------------------->
                      <tr>
                        <td [attr.colspan]="parentStepTen[iParent]?.repeat ? 
                        (1 + parentStepTen[iParent]?.data?.goal.parentYear.length + 1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3) 
                        : (1 + parentStepTen[iParent]?.data?.goal.year.length + 1 + 3)" style="padding: 0px;">
                          <table class="table-proccess-data">
                            <tr *ngFor="let control of parentStepTen[iParent]?.data?.goal.control; index as iSub">
                              <td
                                style="min-width: 200px; max-width: 200px; vertical-align: middle; padding-top: 5px;padding-bottom: 5px;">
                                <div class="ml-3">
                                  {{control.title}}
                                </div>

                              </td>

                              <td *ngFor="let pTranx of control.parentTranx"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{pTranx}}
                                </div>
                              </td>

                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>

                              <td *ngFor="let tranx of control.tranx"
                                style="min-width: 270px;width: 270px;max-width:  270px; padding: 5px; text-align: center; vertical-align: middle;">
                                <div>
                                  {{tranx}}
                                </div>
                              </td>
                              <td style="min-width: 10px; width: 10px; max-width: 10px;"></td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{control.cumulative}}
                                </div>
                              </td>
                              <td
                                style="padding: 5px; min-width: 470px; width: 470px; max-width: 470px; vertical-align: middle; text-align: center;">
                                <div>
                                  {{control.now}}
                                </div>
                              </td>
                            </tr>
                          </table>
                        </td>
                      </tr>
                      <!-- --------------------------------------------------------------------------------- -->
                      <!-- ==================================== end การควบคุม ============================================ -->

                    </tbody>
                  </table>
                  <br>
                </div>
              </div>
              <div class="col-12">
                <p class="head-detal">กรุณาระบุเหตุผลในกรณีผลการดำเนินงานไม่บรรลุตามเป้าหมาย
                  และผู้จัดการผลิตภัณฑ์เห็นสมควร</p>
              </div>
              <div class="col-12">
                <textarea class="form-control input-detail" rows="4" cols="50" placeholder="เพิ่มรายละเอียดเหตุผล"
                  [(ngModel)]="parentStepTen[iParent]?.data.reason" disabled></textarea>
              </div>
            </div>

          </div>
          <!--------------------------------------------------------------------------------->
          <!-- ============================================================================ -->

        </div>
      </div>
    </div>
  </div>
  <!-- end each collapse -->

</div>
<!-- ------------------------------------------------------------------------------------------------------------------ -->
<div [ngStyle]="{'display': template_manage.caaStatus === 'show' ? 'none' : '' }">
  <br />
  <br />

  <div class="row" *ngIf="(validate === true || validate === null)">
    <div class="col-12">
      <button class="btn btn-outline-secondary button-next" type="button" (click)="next_step()">
        ถัดไป
      </button>
    </div>
  </div>
  <br />
</div>
<div class="row" *ngIf="validate === false"
  [ngStyle]="{'display': template_manage.caaStatus === 'show' ? 'none' : '' }">
  <div class="col-12">
    <button class="btn btn-outline-secondary button-next" type="button" (click)="viewNext()">ถัดไป</button>
  </div>
</div>
<br>